SET i assets /i1*i6/;

SET s scenarios /s1*s100/;


PARAMETER Wbar target wealth
/ 95 /;

PARAMETER W0 initial wealth
/ 100 /;

PARAMETER ps probability
/ 0.01 /;

PARAMETER alpha confidence level
/ 0.05 /;

TABLE returns(s,i)  required materials
$INCLUDE "returnMat.txt";

Positive variables x(i);
Positive Variables ws(s);
Positive variables z(s);
Variable obj;
Variable a;

EQUATIONS        ObjFn,
                 constrForAVaR,
                 wealthDef,
                 PtfEqualW0,
                 targetWealthCons;

ObjFn..              obj =e= -a + 1/alpha*(sum(s,z(s)*ps));
constrForAVaR(s) ..  -a+ws(s)+z(s) =g= 0;

wealthDef(s)..       ws(s) =e= sum(i,x(i)*(1+returns(s,i)));
PtfEqualW0..         sum(i,x(i)) =e= W0;
targetWealthCons..   sum(s,ws(s)*ps) =g= Wbar;
*------------------------------------------------------------------------------
* Model declaration

MODEL AVaRoptimization /all/ ;

*------------------------------------------------------------------------------
* Solve and display results

SOLVE  AVaRoptimization minimizing obj using LP;
DISPLAY x.l,a.l;

